"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var react_native_reanimated_1 = __importStar(require("react-native-reanimated"));
var constants_1 = require("./constants");
var context_1 = require("./context");
var types_1 = require("./types");
var useCellTranslate_1 = require("./useCellTranslate");
function CellRendererComponent(props) {
    var item = props.item, index = props.index, children = props.children;
    var currentIndexAnim = react_native_reanimated_1.useSharedValue(index);
    currentIndexAnim.value = index;
    var viewRef = react_1.useRef(null);
    var _a = context_1.useStaticValues(), cellDataRef = _a.cellDataRef, activeIndexAnim = _a.activeIndexAnim, isHovering = _a.isHovering, horizontalAnim = _a.horizontalAnim, keyExtractor = _a.keyExtractor, flatlistRef = _a.flatlistRef, propsRef = _a.propsRef;
    var _b = context_1.useActiveKey(), activeKey = _b.activeKey, isActiveVisible = _b.isActiveVisible;
    var horizontal = context_1.useProps().horizontal;
    var key = keyExtractor(item, index);
    var offset = react_native_reanimated_1.useSharedValue(-1);
    var size = react_native_reanimated_1.useSharedValue(-1);
    var translate = useCellTranslate_1.useCellTranslate({
        cellOffset: offset,
        cellSize: size,
        cellIndex: currentIndexAnim,
    });
    var style = react_native_reanimated_1.useAnimatedStyle(function () {
        return {
            transform: [
                horizontalAnim.value
                    ? { translateX: translate.value }
                    : { translateY: translate.value },
            ],
        };
    });
    var onLayout = function () {
        var onSuccess = function (x, y, w, h) {
            var cellOffset = horizontal ? x : y;
            var cellSize = horizontal ? w : h;
            if (isHovering.value && activeIndexAnim.value === index) {
                // Skip measurement for active item -- it will be incorrect
                return;
            }
            cellDataRef.current.set(key, {
                measurements: { size: cellSize, offset: cellOffset },
            });
            size.value = cellSize;
            offset.value = cellOffset;
        };
        var onFail = function () {
            var _a;
            if ((_a = propsRef.current) === null || _a === void 0 ? void 0 : _a.debug) {
                console.log("## on measure fail, index: " + index);
            }
        };
        var viewNode = viewRef.current;
        var flatListNode = flatlistRef.current;
        if (viewNode && flatListNode) {
            //@ts-ignore
            var nodeHandle = react_native_1.findNodeHandle(flatListNode);
            //@ts-ignore
            if (nodeHandle)
                viewNode.measureLayout(nodeHandle, onSuccess, onFail);
        }
    };
    var isActive = activeKey === key;
    // changing zIndex crashes android:
    // https://github.com/facebook/react-native/issues/28751
    return (react_1.default.createElement(react_native_reanimated_1.default.View, { ref: viewRef, onLayout: onLayout, style: [
            style,
            constants_1.isIOS && { zIndex: isActive ? 999 : 0 },
            constants_1.isAndroid && { elevation: isActive ? 1 : 0 },
            !activeKey && { transform: [] },
        ] },
        react_1.default.createElement(react_native_reanimated_1.default.View, { pointerEvents: activeKey ? "none" : "auto", style: { flexDirection: horizontal ? "row" : "column" } }, children)));
}
exports.default = types_1.typedMemo(CellRendererComponent);
