"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_native_1 = require("react-native");
var react_native_reanimated_1 = __importStar(require("react-native-reanimated"));
var context_1 = require("./context");
var types_1 = require("./types");
function PlaceholderItem(_a) {
    var _b;
    var renderPlaceholder = _a.renderPlaceholder;
    var _c = context_1.useStaticValues(), horizontalAnim = _c.horizontalAnim, activeCellSize = _c.activeCellSize, keyToIndexRef = _c.keyToIndexRef, placeholderScreenOffset = _c.placeholderScreenOffset, propsRef = _c.propsRef, spacerIndexAnim = _c.spacerIndexAnim;
    var _d = context_1.useActiveKey(), activeKey = _d.activeKey, isActiveVisible = _d.isActiveVisible;
    var onPlaceholderIndexChange = react_1.useCallback(function (_a) {
        var _b, _c;
        var placeholderIndex = _a.placeholderIndex;
        if (placeholderIndex !== -1) {
            (_c = (_b = propsRef.current) === null || _b === void 0 ? void 0 : _b.onPlaceholderIndexChange) === null || _c === void 0 ? void 0 : _c.call(_b, placeholderIndex);
        }
    }, [propsRef]);
    react_native_reanimated_1.useDerivedValue(function () {
        react_native_reanimated_1.runOnJS(onPlaceholderIndexChange)({
            placeholderIndex: spacerIndexAnim.value,
        });
    });
    var style = react_native_reanimated_1.useAnimatedStyle(function () {
        return horizontalAnim.value
            ? {
                width: activeCellSize.value,
                transform: [{ translateX: placeholderScreenOffset.value }],
            }
            : {
                height: activeCellSize.value,
                transform: [{ translateY: placeholderScreenOffset.value }],
            };
    });
    var activeIndex = isActiveVisible && activeKey
        ? keyToIndexRef.current.get(activeKey)
        : undefined;
    var activeItem = activeIndex === undefined ? null : (_b = propsRef.current) === null || _b === void 0 ? void 0 : _b.data[activeIndex];
    return (react_1.default.createElement(react_native_reanimated_1.default.View, { pointerEvents: isActiveVisible ? "auto" : "none", style: [react_native_1.StyleSheet.absoluteFill, style] }, !activeItem || activeIndex === undefined
        ? null
        : renderPlaceholder === null || renderPlaceholder === void 0 ? void 0 : renderPlaceholder({ item: activeItem, index: activeIndex })));
}
exports.default = types_1.typedMemo(PlaceholderItem);
