"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _reactNativeReanimated = _interopRequireWildcard(require("react-native-reanimated"));

var _AnimatedValueContext = require("../context/AnimatedValueContext");

var _DraggableFlatListContext = require("../context/DraggableFlatListContext");

var _PropsContext = require("../context/PropsContext");

var _RefContext = require("../context/RefContext");

var _useNode = require("../hooks/useNode");

var _utils = require("../utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function PlaceholderItem({
  renderPlaceholder
}) {
  var _propsRef$current2;

  const {
    activeCellSize,
    placeholderScreenOffset,
    spacerIndexAnim
  } = (0, _AnimatedValueContext.useAnimatedValues)();
  const {
    keyToIndexRef,
    propsRef
  } = (0, _RefContext.useRefs)();
  const {
    activeKey
  } = (0, _DraggableFlatListContext.useDraggableFlatListContext)();
  const {
    horizontal
  } = (0, _PropsContext.useProps)(); // for some reason using placeholderScreenOffset directly is buggy

  const translate = (0, _reactNativeReanimated.useValue)(0);
  const onPlaceholderIndexChange = (0, _react.useCallback)(index => {
    var _propsRef$current$onP, _propsRef$current;

    (_propsRef$current$onP = (_propsRef$current = propsRef.current).onPlaceholderIndexChange) === null || _propsRef$current$onP === void 0 ? void 0 : _propsRef$current$onP.call(_propsRef$current, index);
  }, [propsRef]);
  (0, _reactNativeReanimated.useCode)(() => (0, _reactNativeReanimated.onChange)(spacerIndexAnim, (0, _reactNativeReanimated.call)([spacerIndexAnim], ([i]) => {
    onPlaceholderIndexChange(i);
  })), []);
  const translateKey = horizontal ? "translateX" : "translateY";
  const sizeKey = horizontal ? "width" : "height";
  const opacity = (0, _useNode.useNode)((0, _reactNativeReanimated.cond)((0, _reactNativeReanimated.greaterThan)(spacerIndexAnim, -1), 1, 0));
  const activeIndex = activeKey ? keyToIndexRef.current.get(activeKey) : undefined;
  const activeItem = activeIndex === undefined ? null : (_propsRef$current2 = propsRef.current) === null || _propsRef$current2 === void 0 ? void 0 : _propsRef$current2.data[activeIndex];
  const animStyle = {
    opacity,
    [sizeKey]: activeCellSize,
    transform: [{
      [translateKey]: translate
    }]
  };
  return /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.View, {
    pointerEvents: activeKey ? "auto" : "none",
    style: [_reactNative.StyleSheet.absoluteFill, animStyle]
  }, !activeItem || activeIndex === undefined ? null : renderPlaceholder === null || renderPlaceholder === void 0 ? void 0 : renderPlaceholder({
    item: activeItem,
    index: activeIndex
  }), /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.Code, null, () => (0, _reactNativeReanimated.set)(translate, placeholderScreenOffset)));
}

var _default = (0, _utils.typedMemo)(PlaceholderItem);

exports.default = _default;
//# sourceMappingURL=PlaceholderItem.js.map