"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _DraggableFlatListContext = require("../context/DraggableFlatListContext");

var _RefContext = require("../context/RefContext");

var _utils = require("../utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function RowItem(props) {
  const propsRef = (0, _react.useRef)(props);
  propsRef.current = props;
  const {
    activeKey
  } = (0, _DraggableFlatListContext.useDraggableFlatListContext)();
  const activeKeyRef = (0, _react.useRef)(activeKey);
  activeKeyRef.current = activeKey;
  const {
    keyToIndexRef
  } = (0, _RefContext.useRefs)();
  const drag = (0, _react.useCallback)(() => {
    const {
      drag,
      itemKey,
      debug
    } = propsRef.current;

    if (activeKeyRef.current) {
      // already dragging an item, noop
      if (debug) console.log("## attempt to drag item while another item is already active, noop");
    }

    drag(itemKey);
  }, []);
  const {
    renderItem,
    item,
    itemKey
  } = props;
  return /*#__PURE__*/_react.default.createElement(MemoizedInner, {
    isActive: activeKey === itemKey,
    drag: drag,
    renderItem: renderItem,
    item: item,
    index: keyToIndexRef.current.get(itemKey)
  });
}

var _default = (0, _utils.typedMemo)(RowItem);

exports.default = _default;

function Inner({
  isActive,
  item,
  drag,
  index,
  renderItem
}) {
  return renderItem({
    isActive,
    item,
    drag,
    index
  });
}

const MemoizedInner = (0, _utils.typedMemo)(Inner);
//# sourceMappingURL=RowItem.js.map