"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isReanimatedV2 = exports.isWeb = exports.isAndroid = exports.isIOS = exports.DEFAULT_PROPS = exports.DEFAULT_ANIMATION_CONFIG = exports.SCROLL_POSITION_TOLERANCE = void 0;

var _reactNative = require("react-native");

var _reactNativeReanimated = require("react-native-reanimated");

// Fire onScrollComplete when within this many px of target offset
const SCROLL_POSITION_TOLERANCE = 2;
exports.SCROLL_POSITION_TOLERANCE = SCROLL_POSITION_TOLERANCE;
const DEFAULT_ANIMATION_CONFIG = {
  damping: 20,
  mass: 0.2,
  stiffness: 100,
  overshootClamping: false,
  restSpeedThreshold: 0.2,
  restDisplacementThreshold: 0.2
};
exports.DEFAULT_ANIMATION_CONFIG = DEFAULT_ANIMATION_CONFIG;
const DEFAULT_PROPS = {
  autoscrollThreshold: 30,
  autoscrollSpeed: 100,
  animationConfig: DEFAULT_ANIMATION_CONFIG,
  scrollEnabled: true,
  dragHitSlop: 0,
  activationDistance: 0,
  dragItemOverflow: false
};
exports.DEFAULT_PROPS = DEFAULT_PROPS;
const isIOS = _reactNative.Platform.OS === "ios";
exports.isIOS = isIOS;
const isAndroid = _reactNative.Platform.OS === "android";
exports.isAndroid = isAndroid;
const isWeb = _reactNative.Platform.OS === "web"; // Is there a better way to check for v2?

exports.isWeb = isWeb;
const isReanimatedV2 = !!_reactNativeReanimated.useSharedValue;
exports.isReanimatedV2 = isReanimatedV2;
//# sourceMappingURL=constants.js.map