"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = CellProvider;
exports.useIsActive = useIsActive;

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const CellContext = /*#__PURE__*/_react.default.createContext(undefined);

function CellProvider({
  isActive,
  children
}) {
  const value = (0, _react.useMemo)(() => ({
    isActive
  }), [isActive]);
  return /*#__PURE__*/_react.default.createElement(CellContext.Provider, {
    value: value
  }, children);
}

function useIsActive() {
  const value = (0, _react.useContext)(CellContext);

  if (!value) {
    throw new Error("useIsActive must be called from within CellProvider!");
  }

  return value.isActive;
}
//# sourceMappingURL=cellContext.js.map