"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = DraggableFlatListProvider;
exports.useDraggableFlatListContext = useDraggableFlatListContext;

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const DraggableFlatListContext = /*#__PURE__*/_react.default.createContext(undefined);

function DraggableFlatListProvider({
  activeKey,
  onDragEnd,
  keyExtractor,
  horizontal,
  children
}) {
  const value = (0, _react.useMemo)(() => ({
    activeKey,
    keyExtractor,
    onDragEnd,
    horizontal
  }), [activeKey, onDragEnd, keyExtractor, horizontal]);
  return /*#__PURE__*/_react.default.createElement(DraggableFlatListContext.Provider, {
    value: value
  }, children);
}

function useDraggableFlatListContext() {
  const value = (0, _react.useContext)(DraggableFlatListContext);

  if (!value) {
    throw new Error("useDraggableFlatListContext must be called within DraggableFlatListProvider");
  }

  return value;
}
//# sourceMappingURL=draggableFlatListContext.js.map