"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useOnCellActiveAnimation = useOnCellActiveAnimation;

var _reactNativeReanimated = require("react-native-reanimated");

var _AnimatedValueContext = require("../context/AnimatedValueContext");

var _CellContext = require("../context/CellContext");

var _procs = require("../procs");

var _useSpring = require("./useSpring");

function useOnCellActiveAnimation({
  animationConfig
} = {
  animationConfig: {}
}) {
  const {
    clock,
    state,
    config
  } = (0, _useSpring.useSpring)({
    config: animationConfig
  });
  const {
    isDraggingCell
  } = (0, _AnimatedValueContext.useAnimatedValues)();
  const isActive = (0, _CellContext.useIsActive)();
  (0, _reactNativeReanimated.useCode)(() => (0, _reactNativeReanimated.block)([(0, _reactNativeReanimated.onChange)(isDraggingCell, [//@ts-ignore
  (0, _reactNativeReanimated.set)(config.toValue, (0, _reactNativeReanimated.cond)(isDraggingCell, 1, 0)), (0, _reactNativeReanimated.startClock)(clock)]), (0, _reactNativeReanimated.cond)((0, _reactNativeReanimated.clockRunning)(clock), [(0, _procs.springFill)(clock, state, config), (0, _reactNativeReanimated.cond)(state.finished, [(0, _reactNativeReanimated.stopClock)(clock), (0, _reactNativeReanimated.set)(state.finished, 0), (0, _reactNativeReanimated.set)(state.time, 0), (0, _reactNativeReanimated.set)(state.velocity, 0)])])]), []);
  return {
    isActive,
    onActiveAnim: state.position
  };
}
//# sourceMappingURL=useOnCellActiveAnimation.js.map