"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSpring = useSpring;

var _react = require("react");

var _reactNativeReanimated = require("react-native-reanimated");

var _constants = require("../constants");

function useSpring({
  config: configParam
} = {
  config: _constants.DEFAULT_ANIMATION_CONFIG
}) {
  const toValue = (0, _reactNativeReanimated.useValue)(0);
  const clock = (0, _react.useMemo)(() => new _reactNativeReanimated.Clock(), []);
  const finished = (0, _reactNativeReanimated.useValue)(0);
  const velocity = (0, _reactNativeReanimated.useValue)(0);
  const position = (0, _reactNativeReanimated.useValue)(0);
  const time = (0, _reactNativeReanimated.useValue)(0);
  const state = (0, _react.useMemo)(() => ({
    finished,
    velocity,
    position,
    time
  }), [finished, velocity, position, time]);
  const config = (0, _react.useMemo)(() => ({ ..._constants.DEFAULT_ANIMATION_CONFIG,
    ...configParam,
    toValue
  }), [configParam, toValue]);
  return (0, _react.useMemo)(() => ({
    clock,
    state,
    config
  }), [clock, state, config]);
}
//# sourceMappingURL=useSpring.js.map