import React from "react";
import { FlatList } from "react-native-gesture-handler";
import Animated from "react-native-reanimated";
import { DraggableFlatListProps } from "./types";
declare type StaticContextValue<T> = {
    cellDataRef: React.MutableRefObject<Map<string, any>>;
    keyToIndexRef: React.MutableRefObject<Map<string, number>>;
    activeIndexAnim: Animated.SharedValue<number>;
    spacerIndexAnim: Animated.SharedValue<number>;
    hoverComponentTranslate: Animated.SharedValue<number>;
    hoverOffset: Animated.SharedValue<number>;
    activeCellSize: Animated.SharedValue<number>;
    activeCellOffset: Animated.SharedValue<number>;
    scrollOffset: Animated.SharedValue<number>;
    placeholderOffset: Animated.SharedValue<number>;
    placeholderScreenOffset: Animated.SharedValue<number>;
    horizontalAnim: Animated.SharedValue<boolean>;
    isHovering: Animated.SharedValue<boolean>;
    animationConfigRef: React.MutableRefObject<Animated.WithSpringConfig>;
    keyExtractor: (item: T, index: number) => string;
    flatlistRef: React.RefObject<FlatList<T>>;
};
declare type ActiveKeyContextValue = {
    activeKey: string | null;
    isActiveVisible: boolean;
};
declare type PropsContextValue = {
    horizontal?: boolean;
};
declare type Props<T> = StaticContextValue<T> & ActiveKeyContextValue & {
    props: DraggableFlatListProps<T>;
    children: React.ReactNode;
};
declare function DraggableFlatListProviderBase<T>({ children, activeIndexAnim, spacerIndexAnim, hoverOffset, horizontalAnim, keyToIndexRef, cellDataRef, activeCellSize, activeCellOffset, scrollOffset, isHovering, animationConfigRef, placeholderOffset, placeholderScreenOffset, hoverComponentTranslate, flatlistRef, activeKey, isActiveVisible, keyExtractor, props, }: Props<T>): JSX.Element;
export declare const DraggableFlatListProvider: typeof DraggableFlatListProviderBase;
export declare function useStaticValues<T>(): StaticContextValue<T>;
export declare function useActiveKey(): ActiveKeyContextValue;
export declare function useProps(): PropsContextValue;
export {};
