"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useProps = exports.useActiveKey = exports.useStaticValues = exports.DraggableFlatListProvider = void 0;
var react_1 = __importStar(require("react"));
var types_1 = require("./types");
// context to hold values that remain referentially equal
var StaticContext = react_1.default.createContext(undefined);
var ActiveKeyContext = react_1.default.createContext(undefined);
var PropsContext = react_1.default.createContext(undefined);
function DraggableFlatListProviderBase(_a) {
    var children = _a.children, activeIndexAnim = _a.activeIndexAnim, spacerIndexAnim = _a.spacerIndexAnim, hoverOffset = _a.hoverOffset, horizontalAnim = _a.horizontalAnim, keyToIndexRef = _a.keyToIndexRef, cellDataRef = _a.cellDataRef, activeCellSize = _a.activeCellSize, activeCellOffset = _a.activeCellOffset, scrollOffset = _a.scrollOffset, isHovering = _a.isHovering, animationConfigRef = _a.animationConfigRef, placeholderOffset = _a.placeholderOffset, placeholderScreenOffset = _a.placeholderScreenOffset, hoverComponentTranslate = _a.hoverComponentTranslate, flatlistRef = _a.flatlistRef, activeKey = _a.activeKey, isActiveVisible = _a.isActiveVisible, keyExtractor = _a.keyExtractor, props = _a.props;
    var propsRef = react_1.useRef(props);
    propsRef.current = props;
    var staticValue = react_1.useMemo(function () {
        return {
            activeIndexAnim: activeIndexAnim,
            spacerIndexAnim: spacerIndexAnim,
            hoverOffset: hoverOffset,
            horizontalAnim: horizontalAnim,
            keyToIndexRef: keyToIndexRef,
            cellDataRef: cellDataRef,
            activeCellSize: activeCellSize,
            activeCellOffset: activeCellOffset,
            scrollOffset: scrollOffset,
            isHovering: isHovering,
            animationConfigRef: animationConfigRef,
            placeholderOffset: placeholderOffset,
            placeholderScreenOffset: placeholderScreenOffset,
            flatlistRef: flatlistRef,
            keyExtractor: keyExtractor,
            hoverComponentTranslate: hoverComponentTranslate,
            propsRef: propsRef,
        };
    }, [
        activeIndexAnim,
        horizontalAnim,
        spacerIndexAnim,
        hoverOffset,
        activeCellSize,
        activeCellOffset,
        scrollOffset,
        isHovering,
        animationConfigRef,
        placeholderOffset,
        placeholderScreenOffset,
        flatlistRef,
        keyExtractor,
        cellDataRef,
        keyToIndexRef,
        hoverComponentTranslate,
    ]);
    var activeKeyValue = react_1.useMemo(function () { return ({
        activeKey: activeKey,
        isActiveVisible: isActiveVisible,
    }); }, [activeKey, isActiveVisible]);
    var propsValue = react_1.useMemo(function () { return ({
        horizontal: !!props.horizontal,
    }); }, [props.horizontal]);
    return (react_1.default.createElement(ActiveKeyContext.Provider, { value: activeKeyValue },
        react_1.default.createElement(StaticContext.Provider, { value: staticValue },
            react_1.default.createElement(PropsContext.Provider, { value: propsValue }, children))));
}
exports.DraggableFlatListProvider = types_1.typedMemo(DraggableFlatListProviderBase);
function useStaticValues() {
    var value = react_1.useContext(StaticContext);
    if (!value) {
        throw new Error("useStaticValues must be called within StaticContext.Provider");
    }
    return value;
}
exports.useStaticValues = useStaticValues;
function useActiveKey() {
    var value = react_1.useContext(ActiveKeyContext);
    if (!value) {
        throw new Error("useActiveKey must be called within ActiveKeyContext.Provider");
    }
    return value;
}
exports.useActiveKey = useActiveKey;
function useProps() {
    var value = react_1.useContext(PropsContext);
    if (!value) {
        throw new Error("useProps must be called within PropsContext.Provider");
    }
    return value;
}
exports.useProps = useProps;
