import React, { useContext, useMemo } from "react";
const CellContext = /*#__PURE__*/React.createContext(undefined);
export default function CellProvider({
  isActive,
  children
}) {
  const value = useMemo(() => ({
    isActive
  }), [isActive]);
  return /*#__PURE__*/React.createElement(CellContext.Provider, {
    value: value
  }, children);
}
export function useIsActive() {
  const value = useContext(CellContext);

  if (!value) {
    throw new Error("useIsActive must be called from within CellProvider!");
  }

  return value.isActive;
}
//# sourceMappingURL=cellContext.js.map