import { useMemo } from "react";
import { Clock, useValue } from "react-native-reanimated";
import { DEFAULT_ANIMATION_CONFIG } from "../constants";
export function useSpring({
  config: configParam
} = {
  config: DEFAULT_ANIMATION_CONFIG
}) {
  const toValue = useValue(0);
  const clock = useMemo(() => new Clock(), []);
  const finished = useValue(0);
  const velocity = useValue(0);
  const position = useValue(0);
  const time = useValue(0);
  const state = useMemo(() => ({
    finished,
    velocity,
    position,
    time
  }), [finished, velocity, position, time]);
  const config = useMemo(() => ({ ...DEFAULT_ANIMATION_CONFIG,
    ...configParam,
    toValue
  }), [configParam, toValue]);
  return useMemo(() => ({
    clock,
    state,
    config
  }), [clock, state, config]);
}
//# sourceMappingURL=useSpring.js.map